//#include <mega168.h>

#include "LCDRoutine.h"

//-------------------------------------------------------
//  LCD Functions
//-------------------------------------------------------
void putlcd(unsigned char moda, unsigned char comm)  {

	  
      //lcd_rs=1;
	  SET(PORT,lcd_rs);
      //if (moda==0) lcd_rs=0;
	  if (moda==0) CLR(PORT,lcd_rs);
            
      //db7out=0;
	  CLR(PORT,db7out);
      //db6out=0;
	  CLR(PORT,db6out);
      //db5out=0;
	  CLR(PORT,db5out);
      //db4out=0;
	  CLR(PORT,db4out);
      
      //if ((comm&0x80)==0x80) db7out=1;
	  if ((comm&0x80)==0x80) SET(PORT,db7out);
      //if ((comm&0x40)==0x40) db6out=1;
	  if ((comm&0x40)==0x40) SET(PORT,db6out);
      //if ((comm&0x20)==0x20) db5out=1;
	  if ((comm&0x20)==0x20) SET(PORT,db5out);
      //if ((comm&0x10)==0x10) db4out=1;
	  if ((comm&0x10)==0x10) SET(PORT,db4out);
      
      //lcd_en=1;
	  SET(PORT,lcd_en);
      _delay_us(5);
      //lcd_en=0; 
      CLR(PORT,lcd_en);  
      _delay_us(5);

      //db7out=0;
	  CLR(PORT,db7out); 
      //db6out=0;
	  CLR(PORT,db6out); 
      //db5out=0;
	  CLR(PORT,db5out); 
      //db4out=0;
	  CLR(PORT,db4out); 

      //if ((comm&0x08)==0x08) db7out=1;
	  if ((comm&0x08)==0x08) SET(PORT,db7out);
      //if ((comm&0x04)==0x04) db6out=1;
	  if ((comm&0x04)==0x04) SET(PORT,db6out);
      //if ((comm&0x02)==0x02) db5out=1;
	  if ((comm&0x02)==0x02) SET(PORT,db5out);
      //if ((comm&0x01)==0x01) db4out=1;
	  if ((comm&0x01)==0x01) SET(PORT,db4out);
      
      //lcd_en=1;
	  SET(PORT,lcd_en);
      _delay_us(5);
      //lcd_en=0;   
	  CLR(PORT,lcd_en);
      _delay_ms(5);
}


void initlcd(void) {
   
   //dirdb4=1;
   SET(DDR,dirdb4);
   //dirdb5=1;
   SET(DDR,dirdb5);
   //dirdb6=1;
   SET(DDR,dirdb6);
   //dirdb7=1;
   SET(DDR,dirdb7);
   //dirrs=1;
   SET(DDR,dirrs);
   //dire=1;
   SET(DDR,dire);

   //lcd_en=0;
   CLR(PORT,lcd_en);
   //lcd_rs=0;
   CLR(PORT,lcd_rs);
   //lcd_rs=1;   
   SET(PORT,lcd_rs);
   _delay_us(5);

   //db7out=0;
   CLR(PORT,db7out);
   //db6out=0;
   CLR(PORT,db6out);
   //db5out=1;
   SET(PORT,db5out);
   //db4out=1;
   SET(PORT,db4out);
   
   //lcd_en=1;
   SET(PORT,lcd_en);
   _delay_us(5);
   //lcd_en=0;  
   CLR(PORT,lcd_en);
   _delay_ms(11);

   //lcd_en=1;
   SET(PORT,lcd_en);
   _delay_us(5);
   //lcd_en=0;
   CLR(PORT,lcd_en);   
   _delay_us(400);

   //lcd_en=1;
   SET(PORT,lcd_en);
   _delay_us(5);
   //lcd_en=0;   
   CLR(PORT,lcd_en);
   _delay_ms(5);

   //db4out=0;
   CLR(PORT,db4out);
   
   //lcd_en=1;
   SET(PORT,lcd_en);
   _delay_us(5);
   //lcd_en=0;   
   CLR(PORT,lcd_en);
   _delay_ms(3);

   putlcd(lcdCmd,functionset);
   putlcd(lcdCmd,cursoroff);
   putlcd(lcdCmd,displayclear);
   putlcd(lcdCmd,entrymode);
}

   

void lcd_putsf(char *str) {

   //while (*str!=0) {
   //   putlcd(lcdData,*str);
   //   *str++;
   //}
	
	int i=0; 
	unsigned char tmp; 
	do 
	{ 
	 tmp =str[i]; 
	 putlcd(lcdData, tmp); 
	 i++; 
	} 
	while(str[i]!=0x00);
   
}

void lcd_putchar(char data) {

	 putlcd(lcdData, data);

}
   


void lcd_putInt(unsigned int value,unsigned char dispNum) {

   unsigned int tempDiv,tempMod,divisor = 1; 
   unsigned char idx; 
   
   dispNum--;
   if (dispNum>5) dispNum = 5; 
   if (dispNum<1) dispNum = 1;   
   for (idx=0;idx<dispNum;idx++) {
        divisor *= 10;
   }       

   do {
        tempDiv = value/divisor; 
        tempMod = value%divisor;
        
        putlcd(lcdData,tempDiv%10 + 0x30);
        value = tempMod;
        if (divisor==1) break;                          
        divisor /= 10;        
                              
        
   } while (1);                
   
}


void lcd_putBin(unsigned char value,unsigned char dispNum) {

   unsigned int tempDiv,tempMod,divisor = 1; 
   unsigned char idx; 
   
   dispNum--;        
   if (dispNum>8) dispNum = 8;
   if (dispNum<1) dispNum = 1;          
   for (idx=0;idx<dispNum;idx++) {
        divisor *= 2;
   }       

   do {
        tempDiv = value/divisor; 
        tempMod = value%divisor;
        
        putlcd(lcdData,tempDiv%2 + 0x30);
        value = tempMod;
        if (divisor==1) break;                         
        divisor /= 2;        
                               
        
   } while (1);                
   
}

void locate(unsigned char lines, unsigned char cols)  {

   unsigned char alamat;

   alamat=((lines-1)*0x40)+(cols-1);
   alamat|=0x80;
   putlcd(lcdCmd,alamat);

}

void lcd_clear(void){
	locate(1,1);
	lcd_putsf("                ");
	locate(2,1);
	lcd_putsf("                ");
}

