#include <util/delay.h>
#include <stdio.h>
#include <avr/io.h>


/* single-bit macros, used for control bits */
#define GLUE(a, b)     a##b
#define SET_(what, p, m) GLUE(what, p) |= (1 << (m))
#define CLR_(what, p, m) GLUE(what, p) &= ~(1 << (m))
#define Invert_(what, p, m) GLUE(what, p) ^= (1 << (m))
#define SET(what, x) SET_(what, x)
#define CLR(what, x) CLR_(what, x)
#define Invert(what, x) Invert_(what, x)

//-------------------------------------------------------
//  LCD Declaration
//-------------------------------------------------------

#define lcd_rs  A,0
#define dirrs   A,0
#define lcd_en  A,2
#define dire    A,2
#define db4out  A,4
#define dirdb4  A,4
#define db5out  A,5
#define dirdb5  A,5
#define db6out  A,6
#define dirdb6  A,6
#define db7out  A,7
#define dirdb7  A,7


/*
#define lcd_rs  PORTB.3
#define dirrs   DDRB.3
#define lcd_en  PORTB.4
#define dire    DDRB.4
#define db4out  PORTC.0
#define dirdb4  DDRC.0
#define db5out  PORTC.1
#define dirdb5  DDRC.1
#define db6out  PORTC.2
#define dirdb6  DDRC.2
#define db7out  PORTC.3
#define dirdb7  DDRC.3
*/

#define displayclear            0x01
#define cursorhome              0x02
#define entrymode               0x06
#define cursoron                0x0F
#define cursoroff               0x0C
#define cursordisplayshift      0x10
#define functionset             0x28
#define setcgram                0x40
#define setddram                0x80
#define lcdData                 1
#define lcdCmd                  0

void lcd_clear(void);
void lcd_putchar(char data);
void initlcd(void);
void putlcd(unsigned char moda, unsigned char comm);
void lcd_putsf(char *str);
void lcd_putInt(unsigned int value,unsigned char dispNum);
void lcd_putBin(unsigned char value,unsigned char dispNum);
void locate(unsigned char lines, unsigned char cols);
