/*
 * main.c
 *
 *  Created on: 5 Jun 2012
 *      Author: SUPPORT 4
 */
//jalannya program dapat dilihat dengan membaca data pada port serial DT-AVR Atmega 128L BMS
//dg setting baudrate 9600, 8, N, 1

#include <avr/interrupt.h>
#include <inttypes.h>
#include <stdio.h>
#include <string.h>
#include <avr/io.h>
#include <avr/iom128.h>
#include <util/delay.h>
#include "main.h"
#include "uart_lib.h"
#include "spi.h"
#include "vinculum_usb_host_SK.h"
#include "vs1011e.h"
#include "LCDRoutine.h"


void check_buffer(){
	unsigned char b,k;
	switch (menuBuffer){

	case detect:

		usart_putsf("case detect !\r");
		//cek buffer for No Disk
		b=0;
		if(buffer[b++]=='N' &&
				buffer[b++]=='o' &&
				buffer[b++]==0x20 &&
				buffer[b++]=='D' &&
				buffer[b++]=='i' &&
				buffer[b++]=='s' &&
				buffer[b++]=='k' ){
			UsbDetected=NO;
			usart_putsf("no usb !\r");
		}

		//cek buffer for Disk Detected
		b=0;
		if(buffer[b++]=='D' &&
				buffer[b++]=='e' &&
				buffer[b++]=='v' &&
				buffer[b++]=='i' &&
				buffer[b++]=='c' &&
				buffer[b++]=='e' &&
				buffer[b++]==0x20 &&
				buffer[b++]=='D' &&
				buffer[b++]=='e' &&
				buffer[b++]=='t' &&
				buffer[b++]=='e' &&
				buffer[b++]=='c' &&
				buffer[b++]=='t' &&
				buffer[b++]=='e' &&
				buffer[b++]=='d' &&
				buffer[b++]==0x20 &&
				buffer[b++]=='P' &&
				buffer[b++]=='2' ){
			UsbDetected=YES;
			usart_putsf("ada usb !\r");
		}

		break;

	case getfilename:
		//get filename which has ".MP3" file extension
		if(buffer[(u-1)]=='3' &&
				buffer[(u-2)]=='P' &&
				buffer[(u-3)]=='M' &&
				buffer[(u-4)]==0x2E){
			for(b=0;b<=u-1;b++){
				filename[trackNumber][b]=buffer[b];
				USART_putchar(filename[trackNumber][b]);
			}
			titleLenght[trackNumber]=(u-1); 	//measure the filename length of current file
			USART_putchar((0x30+trackNumber));	//convert trackNumber to readable ascii
			USART_putchar(13);
			trackAmount=trackNumber;
			trackNumber++;
		}

		break;

	case getfilesize:
		usart_putsf("get file size\r");
		b=0;
		k=0;
		while(k<=titleLenght[trackNumber]){
			if(buffer[b] == filename[trackNumber][b]){
				USART_putchar(buffer[b]);
				USART_putchar(filename[trackNumber][b]);
				b++;
			}k++;
		}
		USART_putchar(13);
		if(buffer[b++]==0x20){
			filesize[0]=buffer[b++];
			filesize[1]=buffer[b++];
			filesize[2]=buffer[b++];
			filesize[3]=buffer[b++];
			usart_putsf("filesize didapatkan=");
			USART_putchar(filesize[3]);
			USART_putchar(filesize[2]);
			USART_putchar(filesize[1]);
			USART_putchar(filesize[0]);
			USART_putchar(13);

		}

		break;

	case none:

		break;
	}
}

unsigned char Mp3State(){
	unsigned char b=0,j=0;
	switch (state) {

	case Start:
		menuBuffer=detect;
		usart_putsf("Tancapkan USB Flashdisk Anda\r");
		lcd_clear();
		locate(1,1);
		lcd_putsf("   Innovative   ");
		locate(2,1);
		lcd_putsf("   Electronics  ");
		_delay_ms(500);
		locate(1,1);
		lcd_putsf(" USB MP3 Player ");
		locate(2,1);
		lcd_putsf("   Starting...  ");
		_delay_ms(300);

		state=SdiskDetection;

		break;

	case SdiskDetection:

		if(UsbDetected==YES){
			locate(2,1);
			lcd_putsf("~USB detected   ");
			_delay_ms(100);
			usart_putsf("USB terdeteksi\r");
			state=SdirUsb;
		}

		if(UsbDetected==NO){
			locate(2,1);
			lcd_putsf("~USB undetected ");
			_delay_ms(100);
			usart_putsf("USB tidak terdeteksi\r");
			state=SdiskDetection;
		}
		break;

	case SdirUsb:
		menuBuffer=getfilename;

		if(UsbDetected==YES){
			usart_putsf("Membaca USB Flashdisk\r");
			locate(2,1);
			lcd_putsf("~Reading USB... ");
			_delay_ms(100);
			printp("dir\r");
			state=Smenu;
		}
		if(UsbDetected==NO)
			state=Start;
		break;

	case Smenu:

		menuBuffer=SdiskDetection;
		b=0; j=0;
		TPlayPausePressed=NO;
		if(UsbDetected==YES){
			trackNumber=1; //reset trackNumber value
			usart_putsf("Memilih track\r");
			locate(1,1);
			lcd_putsf("Select Track    ");
			_delay_ms(100);
			lcd_clear();
			locate(1,1);
			lcd_putsf("Track");
			locate(1,6);
			lcd_putsf("~ ");
			locate(1,8);
			lcd_putchar(0x30+(trackNumber/10 %10));
			locate(1,9);
			lcd_putchar(0x30+(trackNumber %10));
			locate(1,11);
			lcd_putsf("of");
			locate(1,14);
			lcd_putchar(0x30+(trackAmount/10 %10));
			locate(1,15);
			lcd_putchar(0x30+(trackAmount %10));
			while(j<=titleLenght[trackNumber]){
				locate(2,j+1);
				lcd_putchar(filename[trackNumber][j]);
				j++;
			}
			while(TPlayPausePressed==NO){
				b=0; j=0;
				_delay_ms(100);
				locate(1,6);
				lcd_putsf("~ ");

				if(!checkbit(button_pin,Play_or_Pause)){
					_delay_ms(20);
					if(!checkbit(button_pin,Play_or_Pause)){
						TPlayPausePressed=YES;
						usart_putsf("OK, Now Playing..\r");
					}
					else
						TPlayPausePressed=NO;
				}

				if(!checkbit(button_pin,Previous)){
					_delay_ms(20);
					if(!checkbit(button_pin,Previous)){
						if(trackNumber>1){
							trackNumber--;
						}
						if(trackNumber==1){
							trackNumber=1;
						}
						locate(2,1);
						lcd_putsf("                ");
						while(j<=titleLenght[trackNumber]){
							locate(2,j+1);
							lcd_putchar(filename[trackNumber][j]);
							j++;
						}
						USART_putchar(0x30+trackNumber);
						USART_putchar(13);
					}
					locate(1,8);//lcd_gotoxy(7,0);
					lcd_putchar(0x30+(trackNumber/10 %10));
					locate(1,9);//lcd_gotoxy(8,0);
					lcd_putchar(0x30+(trackNumber %10));
				}

				if(!checkbit(button_pin,Next)){
					_delay_ms(20);
					if(!checkbit(button_pin,Next)){
						if(trackNumber==trackAmount){
							trackNumber=trackAmount;
						}
						if(trackNumber<trackAmount){
							trackNumber++;
						}
						locate(2,1);//lcd_gotoxy(0,1);
						lcd_putsf("                ");
						while(b<=titleLenght[trackNumber]){
							locate(2,b+1);//lcd_gotoxy(b,1);
							lcd_putchar(filename[trackNumber][b]);
							b++;
						}
						USART_putchar(0x30+trackNumber);
						USART_putchar(13);
					}
					locate(1,8);//lcd_gotoxy(7,0);
					lcd_putchar(0x30+(trackNumber/10 %10));
					locate(1,9);//lcd_gotoxy(8,0);
					lcd_putchar(0x30+(trackNumber %10));
				}

				_delay_ms(100);
				locate(1,6);//lcd_gotoxy(5,0);
				lcd_putsf(" ~");
			}
			state=SdirFile;
		}

		if(UsbDetected==NO)
			state=Start;
		break;

	case SdirFile:
		b=0;
		menuBuffer=getfilesize;

		locate(2,1);//lcd_gotoxy(0,1);
		lcd_putsf("                ");
		while(b<=titleLenght[trackNumber]){
			locate(2,b+1);//lcd_gotoxy(b,1);
			lcd_putchar(filename[trackNumber][b]);
			b++;
		}


		if(UsbDetected==YES){
			b=0;
			printp("dir ");
			usart_putsf("dir ");
			parallel_output();

			while(j<=titleLenght[trackNumber]){
				parallel_write(filename[trackNumber][b]);
				USART_putchar(filename[trackNumber][b]);
				b++; j++;
			}
			USART_putchar(13);
			parallel_write(13);

			state=SopenFile;
		}
		if(UsbDetected==NO)
			state=Start;
		break;

	case SopenFile:
		b=0;
		usart_putsf("SopenFile\r");
		locate(1,1);//lcd_gotoxy(0,0);
		lcd_putsf("~Opening file   ");
		_delay_ms(100);
		//convert filesize from char to long bytesize
		bytesize=0;
		bytesize = filesize[3];
		bytesize = (bytesize << 8) | filesize[2] ;
		bytesize = (bytesize << 8) | filesize[1] ;
		bytesize = (bytesize << 8) | filesize[0] ;

		menuBuffer=none;

		if(UsbDetected==YES){
			printp("opr ");
			usart_putsf("opr ");
			parallel_output();
			while(j<=titleLenght[trackNumber]){
				parallel_write(filename[trackNumber][b]);
				USART_putchar(filename[trackNumber][b]);
				b++; j++;
			}
			USART_putchar(13);
			parallel_write(13);
			state=SreadFile;
		}

		if(UsbDetected==NO)
			state=Start;
		break;

	case SreadFile:
		b=0; j=0;
		menuBuffer=SdiskDetection;

		usart_putsf("SreadFile\r");
		locate(1,1);					//lcd_gotoxy(0,0);
		lcd_putsf("Playing Track");
		locate(1,15);					//lcd_gotoxy(14,0);
		lcd_putchar(0x30+(trackNumber/10 %10));
		locate(1,16);					//lcd_gotoxy(15,0);
		lcd_putchar(0x30+(trackNumber %10));
		if(UsbDetected==YES){
			vs1011e_sw_reset();			//1011E_sw_reset();
			vs1011e_set_mode_play();	//VS1011E_Set_Mode_Play();
			printp("rdf "); 			//command to read file
			usart_putsf("rdf ");
			parallel_output();
			parallel_write(filesize[3]); 	//size of file
			USART_putchar(filesize[3]);
			parallel_write(filesize[2]);	//size of file
			USART_putchar(filesize[2]);
			parallel_write(filesize[1]);	//size of file
			USART_putchar(filesize[1]);
			parallel_write(filesize[0]);	//size of file
			USART_putchar(filesize[0]);
			USART_putchar(13);
			parallel_write(13);
			cli();	//disable and clear all interrupt

			setbit(MP3_port, XCS);	//leaving SCI mode
			setbit(MP3_port, XDCS); //leaving SDI mode
			_delay_us(1);

			clrbit(MP3_port, XDCS); //enter SDI mode
			a=1;
			while(a<bytesize && TStop==NO){ //loop until all of mp3 data(bytesize) are sent

				if(!checkbit(button_pin,Stop)){
					_delay_ms(20);
					if(!checkbit(button_pin,Stop)){
						TStop=YES;
						locate(1,1);//lcd_gotoxy(0,0);
						lcd_putsf("Track Stoped,   ");
						_delay_ms(50);
					}
				}

				if(!checkbit(button_pin,Play_or_Pause)){
					_delay_ms(20);
					if(!checkbit(button_pin,Play_or_Pause)){
						TPause=YES;
						locate(1,1);
						lcd_putsf("Track Paused,   ");
						_delay_ms(50);
					}
				}

				while(TPause==YES){
					if(!checkbit(button_pin,Play_or_Pause)){
						_delay_ms(20);
						if(!checkbit(button_pin,Play_or_Pause)){
							TPause=NO;
							locate(1,1);
							lcd_putsf("Playing Track");
							_delay_ms(50);
						}
					}
				}

				while(!checkbit(Mp3_pin, DREQ)); 	//check for DREQ
				for(k=0;k<=31;k++){					//do for each 32 bytes of data
					clrbit(MP3_port, XDCS);			//enter SDI mode
					if(!checkbit(rxf_pin,rxf)){		//check if rxf pin is LOW (data form VNC1L is available)
						parallel_input(); 			//set parallel port to input
						temp=parallel_read();		//read parallel port and save it to temp
						SPI(temp); 					//send data(temp) to Mp3 Decoder
						a++;
					}
					setbit(MP3_port, XDCS);			//leaving from SDI mode
				}
			}


			setbit(MP3_port, XDCS);
			vs1011e_send_zero();
			vs1011e_sw_reset();
			vs1011e_set_mode_play();

			state=Smenu;

			sei();
		}

		if(UsbDetected==NO){
			state=Start;
			sei();
		}


		break;

	default:
		break;
	}
}

void ButtonControlInit(){
	//set bit pull up resistor
	setbit(button_port, Play_or_Pause);
	setbit(button_port, Rec);
	setbit(button_port, Stop);
	setbit(button_port, Previous);
	setbit(button_port, Next);

}

void ExtIntInit(){
	// External Interrupt(s) initialization
	// INT0: On
	// INT0 Mode: Low level
	EICRA=0x00;
	EICRB=0x00;
	EIMSK|=(1<<INT0);	//enable External Interrupt 0 INT0 (PD0)
	MCUCR = (1<<IVCE);	//penting untuk meng-enable kan interrupt saat running dg bootloader v1.0 dari Innovative Electronics
	MCUCR = 0;		  	//penting untuk meng-enable kan interrupt saat running dg bootloader v1.0 dari Innovative Electronics
	EIFR|=(1<<INTF0);  	//interrupt flag for INT0
}

ISR(INT0_vect){				//Interrupt Service Routine untuk Eksternal Interup 0
	cli();				 	//Clear all interrupt and disable global interrupt
	parallel_input();		//set port parallel sebagai input
	temp=parallel_read();	//simpan nilai pembacaan port parallel ke variabel temp
	buffer[u]=temp;			//simpan nilai temp pada variabel buffer[u]
	if(buffer[u]==0x0D){	//jika buffer bernilai 0x0D heksa, yang merupakan tanda <CR> atau cariage return-
							//yang menandakan akhir dari baris data.

		check_buffer(); 	//Periksa isi file buffer


		u=0;				//reset nilai index untuk buffer
	}
	else u++;				//tambah nilai index buffer

	sei();					//Enable Global Interrupt
}

int main (void){
	ButtonControlInit();
	initlcd();
	_delay_ms(10);
	lcd_clear();
	ExtIntInit();
	SPI_MasterInit();
	USART_Init(9600);

	state = Start;	//start MP3State() from case:Start

	vs1011e_init();
	vs1011e_reset();

	parallel_init();
	parallel_input();

	u=0;			//buffer array index
	trackNumber=1;	//start the track numbering from 1

	sei();

	while(1){
		Mp3State();
		_delay_ms(250);

	}
}

