/*
 * vs1011e.c
 *
 *  Created on: 1 Jun 2012
 *      Author: SUPPORT 4
 */

#include "vs1011e.h"
#include "main.h"
#include "spi.h"
#include <avr/io.h>
#include <util/delay.h>
#include "uart_lib.h"

void vs1011e_init(){
	setbit(MP3_ddr, XCS);
	setbit(MP3_ddr, SCK);
	setbit(MP3_ddr, SI);
	setbit(MP3_ddr, XRST);
	setbit(MP3_ddr, XDCS);
	clrbit(MP3_ddr, SO);
	clrbit(MP3_ddr, DREQ);
	//setbit(MP3_port, DREQ);
	clrbit(MP3_port, SCK);

	_delay_ms(10);
	setbit(MP3_port, XRST);

	while(!checkbit(Mp3_pin, DREQ));
}

void writeSCI(unsigned char address, unsigned char high_byte, unsigned char low_byte){
	setbit(MP3_port, XCS);

	while(!checkbit(Mp3_pin, DREQ));
	clrbit(MP3_port, XCS);

	SPI(0x02);
	SPI(address);
	SPI(high_byte);
	SPI(low_byte);

	setbit(MP3_port, XCS);
	_delay_ms(100);

}

void vs1011e_sw_reset(){
	int i=0;
	_delay_ms(10);

	writeSCI(SCI_MODE, 0x08, 0x04);
	_delay_ms(1);

	while(!checkbit(Mp3_pin, DREQ));
	writeSCI(SCI_CLOCKF, 0x98, 0x00);
	_delay_ms(1);

	clrbit(MP3_port, XDCS);

	while(!checkbit(Mp3_pin, DREQ));
	SPI(0x53);
	while(!checkbit(Mp3_pin, DREQ));
	for(i=0;i<=1023;i++){
		SPI(0x00);
	}

	setbit(MP3_port, XDCS);
}

void vs1011e_reset(){
	clrbit(MP3_port, XRST);
	_delay_ms(1);

	SPI(0xFF);

	setbit(MP3_port, XCS);
	setbit(MP3_port, XDCS);
	setbit(MP3_port, XRST);

	writeSCI(SCI_VOL, 0xFF, 0xFF);
	writeSCI(SCI_CLOCKF, 0x98, 0x00);

	while(!checkbit(Mp3_pin, DREQ));

	writeSCI(SCI_AUDATA, 0x00, 0x0A);
	_delay_ms(100);

	writeSCI(SCI_VOL, 0xFE, 0xFE);
	writeSCI(SCI_AUDATA, 0xBB, 0x81);
	writeSCI(SCI_VOL, 0x0A, 0x0A);
	vs1011e_sw_reset();
//printf();

}

void vs1011e_sine_test(){
	vs1011e_sw_reset();
	_delay_ms(100);

	SPI(0xFF);
	setbit(MP3_port, XCS);
	setbit(MP3_port, XDCS);
	_delay_ms(100);

	writeSCI(SCI_MODE, 0x08, 0x02);

	while(!checkbit(Mp3_pin, DREQ));
	clrbit(MP3_port, XDCS);
	SPI(0x53);
	SPI(0xEF);
	SPI(0x6E);
	SPI(0x44);
	SPI(0x00);
	SPI(0x00);
	SPI(0x00);
	SPI(0x00);
	setbit(MP3_port, XDCS);
	_delay_ms(200);

	while(!checkbit(Mp3_pin, DREQ));
	clrbit(MP3_port, XDCS);
	SPI(0x45);
	SPI(0x78);
	SPI(0x69);
	SPI(0x74);
	SPI(0x00);
	SPI(0x00);
	SPI(0x00);
	SPI(0x00);
	setbit(MP3_port, XDCS);
	_delay_ms(200);

}

void vs1011e_set_mode_play(){

	writeSCI(SCI_MODE, 0x08, 0x00); /* WriteSCI New Mode, No Reset, No test */
	writeSCI(SCI_VOL, 0xFF, 0xFF);

	writeSCI(SCI_CLOCKF, 0x98, 0x00);
	_delay_ms(1);

	while(!checkbit(Mp3_pin, DREQ));
	writeSCI(SCI_AUDATA, 0x00, 0x0A);

	_delay_ms(100);

	writeSCI(SCI_VOL, 0xFE, 0xFE);
	writeSCI(SCI_AUDATA, 0xBB, 0x81);
	writeSCI(SCI_VOL, 0x28, 0x05);

	setbit(MP3_port, XCS);
	setbit(MP3_ddr, XDCS);
	_delay_ms(100);

}

void vs1011e_send_zero(){

	int i=0;
	setbit(MP3_port, XCS);
	clrbit(MP3_ddr, XDCS);
	for(i=0;i<1048;i++){
		while(!checkbit(Mp3_pin, DREQ));
		SPI(0x00);
	}
	setbit(MP3_ddr, XDCS);
}


